var toCamelCase = require('to-camel-case');
var Info = require('../Info.js');
var type = function (object) {
	return {}.toString.call(object).match(/\[object (.*?)\]/)[1].toLowerCase();
};
// 不进行rem转换的属性列表
var propertiesThatMustBeStrings = ["font-weight", "fontWeight","flex","z-index","zIndex","opacity","flexBasis","flexShrink","flexGrow"];
// 不可用属性
var inValidStyle = [
    'z-index',
    'user-select',
    'min-height',
    'min-width',
    'max-width',
    'max-height',
    'background-image',
    'background-repeat',
    'background-size',
    'background-position',
    'white-space',
    'display',
    "box-shadow",
    "text-align",
    "vertical-align"
];

module.exports = function (keys) {
    var me = this;
    var flag = false;
    keys.forEach(function(key,index){
        if(inValidStyle.indexOf(key.key) > -1){
            flag = true;
        }
    })
    if(flag){
        Info.info(`文件路径：${me.sourcePath}`);
        flag = false;
    }
	keys.forEach(function (key, index, arr) {
        if(inValidStyle.indexOf(key.key) > -1 && me.sourcePath){
            Info.warning(`weex暂不支持${key.key}属性`);
        }
		var value = key.value;
		if (type(key.value) == 'string') {
			if (value == "true" || value == "false") {
				arr[index].value = value == "true";
			} else {
				value = key.value.replace(/px|em/g, '');
				// console.log(value);
				if (_isNumeric(value) && propertiesThatMustBeStrings.indexOf(arr[index].key) === -1) {
					arr[index].value = parseFloat(value)*2+'rem';
				}
			}
		}
		else if (type(key.value) == 'object') {
			for (var prop in key.value) {
				if (type(key.value[prop]) == 'string') {
					value = key.value[prop].replace(/px|em/g, '');
					if (_isNumeric(value)) {
						arr[index].value[prop] = parseInt(value)*2+'rem';
					}
				}
			}
		}
		arr[index].key = toCamelCase(arr[index].key);
	});
};


function _isNumeric(num) {
	return !isNaN(num)
}
