'use strict';
var chai = require('chai');
var expect = chai.expect;
var Help = require('./help.js');
var Path = require('path');
const cssPath = Path.resolve(__dirname,'./base.css');
const Styles = Help.getParse(cssPath);

describe('样式测试', () => {
    // margin padding length
  function Style_4_length(key) {
    expect(Styles[key][key + 'Top']).to.equal('2rem');
    expect(Styles[key][key + 'Right']).to.equal('4rem');
    expect(Styles[key][key + 'Bottom']).to.equal('6rem');
    expect(Styles[key][key + 'Left']).to.equal('8rem');
  }

  it('should separate Margin && Padding value', () => {
      Style_4_length('margin');
      Style_4_length('padding');
  });

  it('should border value parse', () => {
      expect(Styles['border']['borderWidth']).to.equal('2rem');
      expect(Styles['border']['borderStyle']).to.equal('solid');
      expect(Styles['border']['borderColor']).to.equal('red');
  });

  it('should opacity value parse', () => {
      expect(Styles['opacity']['opacity']).to.equal('0.5');
  });

  it('should flex value parse', () => {
      expect(Styles['flex']['flexGrow']).to.equal('1');
      expect(Styles['flex']['flexShrink']).to.equal('2');
      expect(Styles['flex']['flexBasis']).to.equal('3');
  });
  it('should z-index value parse',() => {
      expect(Styles['z-index']['zIndex']).to.equal('100');
  })
});
